// Adrian Panaete
// 30-40 pct

#include <cstdio>
#include <iostream>
#include<cmath>
#include<algorithm>
#define N 1000010

using namespace std;
struct punct
{
    double X,Y;
    punct()
    {
        Y=0.0;Y=0.0;
    }
    punct(double x,double y)
    {
        X=x;Y=y;
    }
};
int t,n,i;
double x,y,xmin,xmax,ymin,ymax,a_lo,a_hi,a_mi,lo,hi,mi,eps=0.0000000001;
punct z[N],Z,rotat(punct,double);
void rezolva();
int main()
{
    freopen("tarc.in","r",stdin);
    freopen("tarc.out","w",stdout);
    scanf("%d",&t);
    for(;t;t--)
        rezolva();
    return 0;
}
void rezolva()
{
    scanf("%d",&n);
    for(i=1;i<=n;i++)
    {
         scanf("%lf%lf",&x,&y);
         z[i]=punct(x,y);
    }
    xmin=xmax=z[1].X;
    ymin=ymax=z[1].Y;
    for(i=1;i<=n;i++)
    {
        xmin=min(xmin,z[i].X);
        xmax=max(xmax,z[i].X);
        ymin=min(ymin,z[i].Y);
        ymax=max(ymax,z[i].Y);
    }
    lo=ymax-ymin-xmax+xmin;a_lo=0;
    a_hi=acos(-1)/2;
    Z=rotat(z[1],a_hi);
    xmin=xmax=Z.X;
    ymin=ymax=Z.Y;
    for(i=1;i<=n;i++)
    {
        Z=rotat(z[i],a_hi);
        xmin=min(xmin,Z.X);
        xmax=max(xmax,Z.X);
        ymin=min(ymin,Z.Y);
        ymax=max(ymax,Z.Y);
    }
    hi=ymax-ymin-xmax+xmin;
    for(int step=30;step;step--)
    {
        a_mi=(a_hi+a_lo)/2;
        Z=rotat(z[1],a_mi);
        xmin=xmax=Z.X;
        ymin=ymax=Z.Y;
        for(i=1;i<=n;i++)
        {
            Z=rotat(z[i],a_mi);
            xmin=min(xmin,Z.X);
            xmax=max(xmax,Z.X);
            ymin=min(ymin,Z.Y);
            ymax=max(ymax,Z.Y);
        }
        mi=ymax-ymin-xmax+xmin;
        if(step==1)
        {
            cout.setf(ios::fixed, ios::floatfield);
            cout.precision(6);
            Z=punct(xmin,ymin);
            Z=rotat(Z,-a_mi);
            cout<<Z.X<<' '<<Z.Y<<'\n';


            Z=punct(xmin,ymax);
            Z=rotat(Z,-a_mi);
            cout<<Z.X<<' '<<Z.Y<<'\n';

            Z=punct(xmax,ymax);
            Z=rotat(Z,-a_mi);
            cout<<Z.X<<' '<<Z.Y<<'\n';

            Z=punct(xmax,ymin);
            Z=rotat(Z,-a_mi);
            cout<<Z.X<<' '<<Z.Y<<'\n';
            break;
        }
        if(hi*mi>=eps){ hi=mi;a_hi=a_mi;}
        else { lo=mi;a_lo=a_mi;}
    }

}
punct rotat(punct P,double u)
{
    return punct(P.X*cos(u)-P.Y*sin(u),y=P.X*sin(u)+P.Y*cos(u));
}
